# -*- coding: shift-jis -*-
#
# ChangeLog
# - V2.2
#   -- distribution IvV̒ǉ
#   -- qXgOꍇ AIC ̎Zo@̏C
#
# - V2.1
#   -- qXgOꍇ/ȂꍇŔrāA
#      AIC̑傫ȕ̗p郍WbNɕύX
#   -- qXgO̍ۂ̃vbg]uɕύX
#
# - V2.0
#   --  histogram ǉBftHg False ŁA
#      False  FY2014 ŁB
#      True ̋ǉB
#

visualize.infoStat<-function(inputFILE,colTypesFILE,workDIR="./",distribution=T,histogram=T){
####ŌĂяo֐Q̒`####
is.na.cap.xy<-function(vec.x,vec.y){
    temp.vec.x<-vec.x[complete.cases(vec.x,vec.y)]
    temp.vec.y<-vec.y[complete.cases(vec.x,vec.y)]
    if(length(temp.vec.x) == 0 || length(temp.vec.y) == 0 ){
        TRUE
    }else{
        FALSE
    }
}
.new.chisq <- function(vec1, vec2) {
    res.test <- suppressWarnings(
    chisq.test(cbind(vec1, vec2), correct=F));
    m.exp <- res.test$exp;
    m.exp <- ifelse(m.exp < 0.5, exp(-1), m.exp);
    m.obs <- res.test$obs;

    res <- sum((m.exp - m.obs)^2 / m.exp);
    return(res)
}
.new.AIC <- function(vec1, vec2) {
    svec <- vec1 + vec2;

    # [␳
    nvec1 <- ifelse(vec1 < 1, exp(-1), vec1);
    nvec2 <- ifelse(vec2 < 1, exp(-1), vec2);
    nsvec <- ifelse(svec < 1, exp(-1), svec);

    # itjΐޓxa
    ent1 <- nvec1 %*% log(nvec1 / sum(nvec1));
    ent2 <- nvec2 %*% log(nvec2 / sum(nvec2));

    # e[ȗΐޓxa
    sent <- nsvec %*% log(nsvec / sum(nsvec));

    # AIC
    res <- as.vector(- 2 * ent1 - 2 * ent2 + 2 * sent + 2 * (length(vec1) - 1))
    return(res);
}

crosscut.dummy<-function(vec.x,vec.y,num){
    rep("(-Inf, Inf]",length(vec.x))
}

crosscut <- function(x, y, num=4, method="AIC") {
    # ]֐
    if (method == "AIC") {
        eval.cross <- .new.AIC;
    } else {
        eval.cross <- .new.chisq;
    }

    # 
    vec.min <- sort(unique(x));
    vec.index <- as.character(1:length(vec.min));
    names(vec.min) <- vec.index;

    # ̃e[u𕪊
    x.index <- vec.index[match(x, vec.min)];
    new.table <- split(y, x.index);

    # Wv\
    st.count <- lapply(new.table, table);

    # ̋
    st.next <- lapply(vec.index,
                      function(i, vec) {
                          pos <- match(i, vec);
                          if (pos == length(vec)) {
                              return(NA);
                          } else {
                              return(vec[pos + 1]);
                          }
                      }, vec=vec.index);
    names(st.next) <- vec.index;

    # AICl
    st.stat <- lapply(vec.index,
                      function(i, list.next, list.count) {
                          i.next <- list.next[[i]];
                          if (is.na(i.next)) {
                              if (method == "AIC") {
                                  return(-Inf);
                              } else {
                                  return(Inf);
                              }
                          } else {
                              i.count <- list.count[[i]];
                              i.next.count <- list.count[[i.next]];
                              res.stat <- eval.cross(i.count, i.next.count);
                              return(res.stat);
                          }
                      }, list.next=st.next, list.count=st.count);
    names(st.stat) <- vec.index;

    # JԂ
    while (num < length(st.stat)) {
        if (method == "AIC") {
            target <- names(which.max(st.stat));
        } else {
            target <- names(which.min(st.stat));
        }
        i.prev <- names(st.next)[match(target, as.vector(st.next))];
        i.next <- st.next[[target]];
        i.new.next <- st.next[[i.next]];

        if (st.stat[[target]] < 0) {
            # őAICEĂij
            # ƂȂꍇɌ~߂
            break;
        }

        # 񐔂̍XV
        new.count <- st.count[[target]] + st.count[[i.next]];
        st.count[[target]] <- new.count;
        st.count[[i.next]] <- NULL;

        # ̋Ԃ̍XV
        st.next[[target]] <- i.new.next;
        st.next[[i.next]] <- NULL;

        # AICl̍XViO̗vfj
        if (!is.na(i.prev)) {
            i.prev.count <- st.count[[i.prev]];
            st.stat[[i.prev]] <- eval.cross(i.prev.count, new.count);
        }

        # AICl̍XVigj
        if (!is.na(i.new.next)) {
            i.next.count <- st.count[[i.new.next]];
            st.stat[[target]] <- eval.cross(new.count, i.next.count);
        } else {
            if (method == "AIC") {
                st.stat[[target]] <- -Inf;
            } else {
                st.stat[[target]] <- Inf;
            }
        }
        st.stat[[i.next]] <- NULL;
    }

    # UʂԂ
    vec.range <- c();
    target <- vec.index[1];
    while(!is.na(target)) {
        vec.range <- c(vec.range, vec.min[target]);
        target <- st.next[[target]];
    }
    vec.range <- c(-Inf, vec.range, max(vec.min));
    vec.range <- unique(vec.range);

    return(cut(x, vec.range));
}


#ϐAlAړIϐÛƂɌĂяo֐
calcAIC.c2d<-function(vec.x,vec.y,num){
    if(! is.na.cap.xy(vec.x,vec.y)){
        not.na.flag.xy<-complete.cases(vec.x,vec.y)
        vec.x<-vec.x[not.na.flag.xy]
        vec.y<-vec.y[not.na.flag.xy]
        vec.x.trans <- crosscut(vec.x,vec.y,num)
        res<-calcAIC.d2d(vec.x.trans,vec.y)
        res
    }else{
        NA
    }
}


#ϐAړIϐƂɘAl̏ꍇɌĂяo֐
calcAIC.c2c<-function(vec.x,vec.y){
    if(!is.na.cap.xy(vec.x,vec.y)){
        not.na.flag.xy<-complete.cases(vec.x,vec.y)
        vec.x<-vec.x[not.na.flag.xy]
        vec.y<-vec.y[not.na.flag.xy]

        if(length(vec.x)>1){
            fit.0<-lm(vec.y~1)
            AIC.0<-extractAIC(fit.0)
            fit.1<-lm(vec.y~vec.x-1)
            AIC.1<-extractAIC(fit.1)
            del<-AIC.1[2]-AIC.0[2]
            delta=c(del)
            n<-2
            while(n < 6){
                del<-extractAIC(lm(vec.y~poly(vec.x,n,raw=T)))[2]-extractAIC(lm(vec.y~1))[2]
                delta<-c(delta,del)
                n<-n+1
            }
            res.vec<-delta/length(vec.x)
            res<-min(res.vec)
            res.n<-which.min(res.vec)
            list(res,res.n)
        }else{
            list(NA,0)
        }
    }else{
        list(NA,0)
    }
}
#ϐUlAړIϐAl̏ꍇɌĂяo֐
calcAIC.d2c<-function(vec.x,vec.y){
    if(! is.na.cap.xy(vec.x,vec.y)){
        not.na.flag.xy<-complete.cases(vec.x,vec.y)
        vec.x<-vec.x[not.na.flag.xy]
        vec.y<-vec.y[not.na.flag.xy]
        fit.0<-lm(vec.y~1)
        AIC.0<-extractAIC(fit.0)
        if(length(table(vec.x))<2){
            fit.1<-lm(vec.y~1)
        }else{
            fit.1<-lm(vec.y~vec.x)
        }
        AIC.1<-extractAIC(fit.1)
        res<-(AIC.1[2]-AIC.0[2])/length(vec.x)
        res
    }else{
        NA
    }
}
#ϐAړIϐƂɗUl̂ƂɌĂяo֐
calcAIC.d2d<-function(vec.x,vec.y){
    if(! is.na.cap.xy(vec.x,vec.y)){
        not.na.flag.xy<-complete.cases(vec.x,vec.y)
        vec.x<-vec.x[not.na.flag.xy]
        vec.y<-vec.y[not.na.flag.xy]
        tbl.y<-table(vec.y)
        r.sum<-sum(tbl.y)
        tbl.vec.y<-as.vector(tbl.y)
        prb.vec.y<-as.vector(tbl.y/r.sum)
        dim.y<-dim(tbl.y)
        # V.2.0 C
        # prb.vec.y  0 ̂Ƃ log  -Inf ɂȂĂ܂
        # Ỏ
        # AIC.1<-- 2 * tbl.vec.y %*% log(prb.vec.y) +2*(dim.y[1]-1)
        AIC.1 <- local({
            innerprod.tbl.prb.y <- local({
                len <- length(tbl.vec.y)
                ret <- sum(mapply(
                    function(i) {
                        tbl.y <- tbl.vec.y[i]
                        return(ifelse(tbl.y == 0, 0, tbl.y*log(prb.vec.y[i])))
                    },
                    1:len
                ))
                as.matrix(ret)
            })
            -2*innerprod.tbl.prb.y+2*(dim.y[1]-1)
        })
        tbl.xy<-table(vec.x,vec.y)

        r.sums<-rowSums(tbl.xy)
        tbl.vec.xy<-as.vector(tbl.xy)
        prb.vec.xy<-as.vector(tbl.xy/r.sums)
        prb.vec.xy[tbl.vec.xy==0]<-1
        dim.xy<-dim(tbl.xy)
        AIC.2<-- 2 * tbl.vec.xy %*% log(prb.vec.xy) +2*dim.xy[1]*(dim.xy[2]-1)

        res<-(AIC.2-AIC.1)/length(vec.x)

        res
    }else{
        NA
    }
}

# ======================================
#
# ȉAScattePlot=F IvVŎg֐
#
# ======================================

BIN.EPSILON<-10^(-6)

#
# numeric f[^K m  bin (factor) ɕϊ֐
#
convert.c2bin <- function(vec, m) {
    max <- max(vec)
    min <- min(vec)
    bin.width <- (max-min)/(m-1)
    # print(bin.width)
    bin.min <- min-bin.width/2
    bin.max <- max+bin.width/2
    # Zɂ锭덷
    # JeSϊG[邽߂ɁA
    # e bin ̍ŏlĂB
    bin.vec <- bin.min+(0:m)*bin.width-BIN.EPSILON
    # mFpBbin.max  bin.vec[m+1] ͈vB
    # print(bin.max)
    bin <- cut(vec, breaks = bin.vec, right = F)
    return(bin)
}

#
# numeric f[^K m  bin ̗vfɕϊ֐
#
convert.cVec2binCount <- function(vec, m) {
    bin <- convert.c2bin(vec, m)
    return(as.data.frame(table(bin)))
}

#
# convert.cVec2binCount ֐ō
# binCount f[^t[ AIC Ԃ֐
#
calcAICOfBinCount <- function(bin_count.df) {
    N <- sum(bin_count.df$Freq)
    m <- length(bin_count.df[,1])
    n.vec <- bin_count.df$Freq
    p.vec <- n.vec/N
    nlogp.vec <- mapply(
        function(i) {
            n <- n.vec[i]
            return(ifelse(n == 0, 0, n*log(p.vec[i])))
        },
        1:m
    )
    aic <- -2*sum(nlogp.vec)-2*N*log(m-1)+2*m
    return(aic)
}

#
#  m ̒T͈͂Ԃ֐
#
calcMRange <- function(vec) {
    N <- length(vec)
    sturges.cdash <- 1+log10(N)/log10(2)
    return(2:(2*floor(sturges.cdash)))
}

#
# AIC  min ƂȂ镪Ԃ֐
#
calcMWithMinAIC <- function(vec) {
    m.range <- calcMRange(vec)
    aic.vec <- mapply(
        function(m) {
            bin_count.df <- convert.cVec2binCount(vec, m)
            return(calcAICOfBinCount(bin_count.df))
        },
        m.range
    )
    id.minAIC <- order(aic.vec)[1]
    m.minAIC <- m.range[id.minAIC]
    return(m.minAIC)
}

#
# df ̐lAł AIC ȂȂ悤
# bin ɕϊ֐
#
convertDf.c2bin <- function(df) {
    ret <- lapply(
        df,
        function(col) {
            if(class(col) != "numeric" & class(col) != "integer") {
                return(col)
            }
            m <- calcMWithMinAIC(col)
            return(convert.c2bin(col, m))
        }
    )
    return(as.data.frame(ret))
}

appendBinDf2nlevelRow <- function(df) {
    ret <- lapply(
        df, 
        function(col) {
            nlevel <- length(levels(col))
            return(c(nlevel, as.integer(col)))
        }
    )
    return(as.data.frame(ret))
}



#
# hist.* ̊֐ŁA
# factor 쐬֐B
# 
#  x
# - 1 ԖځF
# - 2 Ԗڈȍ~F numeric l
# ĂB
#
hist.createFactor <- function(x) {
    x.nlevel <- as.integer(x[1])
    x.vec <- factor(
        x[-1],
        levels=1:x.nlevel
    )
    return(x.vec)
}

#
# Uz}s̔Ίp̕`
#
hist.lowerupper <- function(x, y) {
    par(new = T)
    x.vec <- hist.createFactor(x)
    y.vec <- hist.createFactor(y)
    tb <- table(x.vec, y.vec)
    if(histogram) {
    	barplot(
	  tb,	
##2016.4.28	  col=gray(0:(nrow(tb)-1) / (nrow(tb)-1)),	
          col=grey.colors(nrow(tb)),
          horiz=T, axes=F,
##2016.4.28
           space=0,border=NA
##,yaxt="n"         
        )
    } else {
        barplot(
           sweep(tb, 2, 100 / colSums(tb), "*"),
##2016.4.28           col=gray(0:(nrow(tb)-1) / (nrow(tb)-1)),
           col=grey.colors(nrow(tb)),
           horiz=T, axes=F,
##2016.4.28
           space=0,border=NA
##,yaxt="n"         
        )
    }
}

#
# Uz}s̑Ίp̕`
#
hist.diag <- function(x) {
##2016.4.28
    par(new = T,xaxt="s")
    x.vec <- hist.createFactor(x)
    tb <- table(x.vec)
    barplot(
        tb,
##2016.4.28        horiz=T, axes=F
        axes=F,
        col=grey.colors(length(tb)),
        space=0,border=NA,mgp=c(1,0,0)
    )
##2016.4.28
    par(new=T,xaxt="n")
}

####̓f[^`FbN####
WorkDIR.head=ifelse(substring(workDIR,nchar(workDIR) ,nchar(workDIR))=="/",
           substring(workDIR,1,nchar(workDIR)-1),workDIR)
DataPATH=paste(WorkDIR.head,inputFILE,sep="/")
colTypesPATH=paste(WorkDIR.head,colTypesFILE,sep="/")
#͑Ώۓ̓f[^݂邩mF
if(!file.exists(DataPATH)){
        stop("̓f[^t@C܂B",DataPATH)
}
#t@C(colType.csv)݂邩mF
if(!file.exists(colTypesPATH)){
    stop("̓f[^t@C܂B",colTypesPATH)
}
#t@Č`̊mF
data.header  <-read.table(DataPATH,header=T,nrows=0,sep=",")
colTypes.orig<-read.table(colTypesPATH,
                          colClasses=c("character","character","integer","character"),
                          header=T,sep=",")
nms.data<-names(data.header)
nms.test<-colTypes.orig[[""]]
nms.setdiff<-setdiff(nms.test,nms.data)
if(length(nms.setdiff) > 0 ){
	stop("colType.csvt@C \"\" ̒lsłB̓f[^Ɋ܂܂Ă܂B\n",nms.setdiff)
}
if(any(duplicated(nms.test))){
	stop("colType.csvt@C \"\" ̒lsłBdl܂B\n",nms.test[duplicated(nms.test)])
}
for( nm in nms.test ){
    if(!(colTypes.orig[["`Ώ"]][nms.test==nm] %in% c("T","F"))){
        stop(nm," : colType.csvt@C \"`Ώ\" ̒lsłBT   F w肵ĂB\n")

    }
 }

colTypes<-rep("factor",length(nms.data))
for( nm in nms.test ){
    if(!(colTypes.orig[[""]][nms.test==nm] %in% c("factor","numeric")))
        {
            stop(nm," : colType.csvt@C \"\" ̒lsłBfactor  numeric w肵ĂB\n")
        }
    colTypes[nms.data==nm]<-colTypes.orig[nms.test==nm,""]
}
#####f[^C|[g####
d.orig<-read.table(DataPATH,colClasses=colTypes,header=T,sep=",")
#####f[^̒oE`####
nms<-colTypes.orig[colTypes.orig[["`Ώ"]]=="T",""]
d<-d.orig[nms]
colTypes<-colTypes.orig[colTypes.orig[["`Ώ"]]=="T",""]
attrbt<-colTypes.orig[colTypes.orig[["`Ώ"]]=="T","U"]
if(any(is.na(attrbt))){
    stop("\"U\"Ɍl݂܂BSĐlw肵ĂB")
}
####FY2015ŁBdistribution=T̏ꍇɁAl𗣎UB####
if(distribution) {
    d.hist <-convertDf.c2bin(d)
}
####ϐ֘Ax̃}gbNX̍쐬####
rel.mat<-matrix(ncol=length(nms),nrow=length(nms))
for( i in 1:length(nms)){
    for( j in 1:length(nms)){
        if( i == j ){
            rel.mat[i,j]<-0
        }else{
            if (colTypes[i] == "numeric") {
                if (colTypes[j]=="numeric") {
                    rel.mat[i,j]<-calcAIC.c2c(d[[j]],d[[i]])[[1]]
                } else if (colTypes[j]=="factor") {
                    rel.mat[i,j]<-calcAIC.d2c(d[[j]],d[[i]])
                }
                if (distribution) {
                    if (colTypes[j]=="numeric") {
                        rel.hist<-calcAIC.c2d(d[[j]],d.hist[[i]],num=attrbt[j])
                    } else if (colTypes[j]=="factor") {
                        rel.hist<-calcAIC.d2d(d[[j]],d.hist[[i]])
                    }
                    if (rel.hist < rel.mat[i,j]) {
                        rel.mat[i,j] <- rel.hist;
                    }
                }
            }else if ( colTypes[j]=="numeric" && colTypes[i]=="factor"){
                rel.mat[i,j]<-calcAIC.c2d(d[[j]],d[[i]],num=attrbt[j])
            }else if ( colTypes[j]=="factor" && colTypes[i]=="factor"){
                rel.mat[i,j]<-calcAIC.d2d(d[[j]],d[[i]])
            }
        }
    }
}
#o̓}gbNXf[^t[ɕϊĐ`
temp.rel.df<-data.frame(rel.mat)
names(temp.rel.df)<-nms
res.rel.df<-data.frame(ړIϐ=nms,temp.rel.df)
#ϐ֘Axt@C̏o
filePath.rel<-paste(WorkDIR.head,"ϐԊ֘Axt@C.csv",sep="/")
write.table(res.rel.df,file=filePath.rel,row.names=F,sep=",")

####ϐ֘AxXt@C̍쐬####
rel.mat.char<-matrix("",ncol=length(nms),nrow=length(nms))
rel.mat.char[rel.mat < -0.1]<-"*"
rel.mat.char[-0.1 <= rel.mat & rel.mat < -0.05] <-"#"
rel.mat.char[-0.05 <= rel.mat & rel.mat < -0.01] <-"+"
rel.mat.char[-0.01 <= rel.mat & rel.mat < 0  ] <-"-"
#o̓}gbNXf[^t[ɕϊĐ`
temp.rel.char.df<-data.frame(rel.mat.char)
names(temp.rel.char.df)<-nms
res.rel.char.df<-data.frame(ړIϐ=nms,temp.rel.char.df)
#ϐ֘AxXt@C̏o
filePath.rel.char<-paste(WorkDIR.head,"ϐԊ֘AxXt@C.csv",sep="/")
write.table(res.rel.char.df,file=filePath.rel.char,row.names=F,sep=",")
####ϐԊ֘Axvbg̍쐬#####
library(MASS)
filePath=paste(WorkDIR.head,"ϐԊ֘Axvbg.png",sep="/")
D<-length(nms)
png(filePath,width=800,height=800)
if(distribution) {
##2016.4.28
    par(xaxt="n",yaxt="n")
    pairs(
        appendBinDf2nlevelRow(d.hist),
        diag.panel = hist.diag,
        lower.panel = hist.lowerupper,
        upper.panel = hist.lowerupper
    )
} else {
    panel.hist<-function(x,...){
        if(class(x)=="numeric"){
            par(new=T)
            hist(x,axes=F,ann = F)
        }else{
            par(new=T)
            barplot(table(x))
        }
    }
    pairs(d,nms,,diag.panel=panel.hist,cex=0.7,gap=0.1)
}
dev.off()
}




